#!/bin/bash
#
# make_version.sh
#
# Script to create version.c for version information
#
# Based on script made by Digium
# Mark Spencer <markster@digium.com>
#

INFOFILE="./version.h"
VERSIONFILE="version.c"
rm -f "$VERSIONFILE"

#echo -n "Checking VoicerLib version... "
VVERSION=`sed -n '/.*VOICERLIB_VERSIONNUMBER /s/^.*VOICERLIB_VERSIONNUMBER //p' "$INFOFILE"`
VVERSION=`echo $VVERSION | sed 's/\"//g'`

VVERSION_EXTRA=`sed -n '/.*VOICERLIB_VERSION /s/^.*VOICERLIB_VERSION //p' "$INFOFILE"`
VVERSION_EXTRA=`echo $VVERSION_EXTRA | sed 's/\"//g'`

echo "$VVERSION"
echo "$VVERSION_EXTRA"

echo "/*" >$VERSIONFILE
echo " * automatically generated by $0 `date`" >>$VERSIONFILE
echo " */" >>$VERSIONFILE

cat << END >>$VERSIONFILE

#include "linux_api.h"

static const char voicerlib_version[] = "${VVERSION_EXTRA}";

static const char voicerlib_version_number[] = "${VVERSION}";

const char *GetLinuxVLibVersion(void)
{
	return voicerlib_version;
}

const char *GetLinuxVLibVersionNumber(void)
{
	return voicerlib_version_number;
}

END

echo "${VERSIONFILE} complete."
exit 0

